Code

Make path in tree view look nicer
[git.git] / git-rebase.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano.
4 #
6 USAGE='[--onto <newbase>] <upstream> [<branch>]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name.  When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic.  You will have to resolve any such merge failure
15 and run git rebase --continue.  Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip.  To restore the
17 original <branch> and remove the .dotest working files, use the command
18 git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.  You must be in the top
22 directory of your project to start (or continue) a rebase.
24 Example:       git-rebase master~1 topic
26         A---B---C topic                   A'\''--B'\''--C'\'' topic
27        /                   -->           /
28   D---E---F---G master          D---E---F---G master
29 '
30 . git-sh-setup
32 RESOLVEMSG="
33 When you have resolved this problem run \"git rebase --continue\".
34 If you would prefer to skip this patch, instead run \"git rebase --skip\".
35 To restore the original branch and stop rebasing run \"git rebase --abort\".
36 "
37 unset newbase
38 case "${GIT_USE_RECUR_FOR_RECURSIVE}" in
39 '')
40         strategy=recursive ;;
41 ?*)
42         strategy=recur ;;
43 esac
45 do_merge=
46 dotest=$GIT_DIR/.dotest-merge
47 prec=4
49 continue_merge () {
50         test -n "$prev_head" || die "prev_head must be defined"
51         test -d "$dotest" || die "$dotest directory does not exist"
53         unmerged=$(git-ls-files -u)
54         if test -n "$unmerged"
55         then
56                 echo "You still have unmerged paths in your index"
57                 echo "did you forget update-index?"
58                 die "$RESOLVEMSG"
59         fi
61         if test -n "`git-diff-index HEAD`"
62         then
63                 if ! git-commit -C "`cat $dotest/current`"
64                 then
65                         echo "Commit failed, please do not call \"git commit\""
66                         echo "directly, but instead do one of the following: "
67                         die "$RESOLVEMSG"
68                 fi
69                 printf "Committed: %0${prec}d" $msgnum
70         else
71                 printf "Already applied: %0${prec}d" $msgnum
72         fi
73         echo ' '`git-rev-list --pretty=oneline -1 HEAD | \
74                                 sed 's/^[a-f0-9]\+ //'`
76         prev_head=`git-rev-parse HEAD^0`
77         # save the resulting commit so we can read-tree on it later
78         echo "$prev_head" > "$dotest/prev_head"
80         # onto the next patch:
81         msgnum=$(($msgnum + 1))
82         echo "$msgnum" >"$dotest/msgnum"
83 }
85 call_merge () {
86         cmt="$(cat $dotest/cmt.$1)"
87         echo "$cmt" > "$dotest/current"
88         git-merge-$strategy "$cmt^" -- HEAD "$cmt"
89         rv=$?
90         case "$rv" in
91         0)
92                 return
93                 ;;
94         1)
95                 test -d "$GIT_DIR/rr-cache" && git-rerere
96                 die "$RESOLVEMSG"
97                 ;;
98         2)
99                 echo "Strategy: $rv $strategy failed, try another" 1>&2
100                 die "$RESOLVEMSG"
101                 ;;
102         *)
103                 die "Unknown exit code ($rv) from command:" \
104                         "git-merge-$strategy $cmt^ -- HEAD $cmt"
105                 ;;
106         esac
109 finish_rb_merge () {
110         rm -r "$dotest"
111         echo "All done."
114 while case "$#" in 0) break ;; esac
115 do
116         case "$1" in
117         --continue)
118                 diff=$(git-diff-files)
119                 case "$diff" in
120                 ?*)     echo "You must edit all merge conflicts and then"
121                         echo "mark them as resolved using git update-index"
122                         exit 1
123                         ;;
124                 esac
125                 if test -d "$dotest"
126                 then
127                         prev_head="`cat $dotest/prev_head`"
128                         end="`cat $dotest/end`"
129                         msgnum="`cat $dotest/msgnum`"
130                         onto="`cat $dotest/onto`"
131                         continue_merge
132                         while test "$msgnum" -le "$end"
133                         do
134                                 call_merge "$msgnum"
135                                 continue_merge
136                         done
137                         finish_rb_merge
138                         exit
139                 fi
140                 git am --resolved --3way --resolvemsg="$RESOLVEMSG" \
141                         --reflog-action=rebase
142                 exit
143                 ;;
144         --skip)
145                 if test -d "$dotest"
146                 then
147                         prev_head="`cat $dotest/prev_head`"
148                         end="`cat $dotest/end`"
149                         msgnum="`cat $dotest/msgnum`"
150                         msgnum=$(($msgnum + 1))
151                         onto="`cat $dotest/onto`"
152                         while test "$msgnum" -le "$end"
153                         do
154                                 call_merge "$msgnum"
155                                 continue_merge
156                         done
157                         finish_rb_merge
158                         exit
159                 fi
160                 git am -3 --skip --resolvemsg="$RESOLVEMSG" \
161                         --reflog-action=rebase
162                 exit
163                 ;;
164         --abort)
165                 if test -d "$dotest"
166                 then
167                         rm -r "$dotest"
168                 elif test -d .dotest
169                 then
170                         rm -r .dotest
171                 else
172                         die "No rebase in progress?"
173                 fi
174                 git reset --hard ORIG_HEAD
175                 exit
176                 ;;
177         --onto)
178                 test 2 -le "$#" || usage
179                 newbase="$2"
180                 shift
181                 ;;
182         -M|-m|--m|--me|--mer|--merg|--merge)
183                 do_merge=t
184                 ;;
185         -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
186                 --strateg=*|--strategy=*|\
187         -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
188                 case "$#,$1" in
189                 *,*=*)
190                         strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
191                 1,*)
192                         usage ;;
193                 *)
194                         strategy="$2"
195                         shift ;;
196                 esac
197                 do_merge=t
198                 ;;
199         -*)
200                 usage
201                 ;;
202         *)
203                 break
204                 ;;
205         esac
206         shift
207 done
209 case "$strategy,${GIT_USE_RECUR_FOR_RECURSIVE}" in
210 recursive,?*)
211         strategy=recur ;;
212 esac
214 # Make sure we do not have .dotest
215 if test -z "$do_merge"
216 then
217         if mkdir .dotest
218         then
219                 rmdir .dotest
220         else
221                 echo >&2 '
222 It seems that I cannot create a .dotest directory, and I wonder if you
223 are in the middle of patch application or another rebase.  If that is not
224 the case, please rm -fr .dotest and run me again.  I am stopping in case
225 you still have something valuable there.'
226                 exit 1
227         fi
228 else
229         if test -d "$dotest"
230         then
231                 die "previous dotest directory $dotest still exists." \
232                         'try git-rebase < --continue | --abort >'
233         fi
234 fi
236 # The tree must be really really clean.
237 git-update-index --refresh || exit
238 diff=$(git-diff-index --cached --name-status -r HEAD)
239 case "$diff" in
240 ?*)     echo "$diff"
241         exit 1
242         ;;
243 esac
245 # The upstream head must be given.  Make sure it is valid.
246 upstream_name="$1"
247 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
248     die "invalid upstream $upstream_name"
250 # If a hook exists, give it a chance to interrupt
251 if test -x "$GIT_DIR/hooks/pre-rebase"
252 then
253         "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
254                 echo >&2 "The pre-rebase hook refused to rebase."
255                 exit 1
256         }
257 fi
259 # If the branch to rebase is given, first switch to it.
260 case "$#" in
261 2)
262         branch_name="$2"
263         git-checkout "$2" || usage
264         ;;
265 *)
266         branch_name=`git symbolic-ref HEAD` || die "No current branch"
267         branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
268         ;;
269 esac
270 branch=$(git-rev-parse --verify "${branch_name}^0") || exit
272 # Make sure the branch to rebase onto is valid.
273 onto_name=${newbase-"$upstream_name"}
274 onto=$(git-rev-parse --verify "${onto_name}^0") || exit
276 # Now we are rebasing commits $upstream..$branch on top of $onto
278 # Check if we are already based on $onto, but this should be
279 # done only when upstream and onto are the same.
280 mb=$(git-merge-base "$onto" "$branch")
281 if test "$upstream" = "$onto" && test "$mb" = "$onto"
282 then
283         echo >&2 "Current branch $branch_name is up to date."
284         exit 0
285 fi
287 # Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
288 git-reset --hard "$onto"
290 # If the $onto is a proper descendant of the tip of the branch, then
291 # we just fast forwarded.
292 if test "$mb" = "$branch"
293 then
294         echo >&2 "Fast-forwarded $branch_name to $onto_name."
295         exit 0
296 fi
298 if test -z "$do_merge"
299 then
300         git-format-patch -k --stdout --full-index "$upstream"..ORIG_HEAD |
301         git am --binary -3 -k --resolvemsg="$RESOLVEMSG" \
302                 --reflog-action=rebase
303         exit $?
304 fi
306 if test "@@NO_PYTHON@@" && test "$strategy" = "recursive"
307 then
308         die 'The recursive merge strategy currently relies on Python,
309 which this installation of git was not configured with.  Please consider
310 a different merge strategy (e.g. octopus, resolve, stupid, ours)
311 or install Python and git with Python support.'
313 fi
315 # start doing a rebase with git-merge
316 # this is rename-aware if the recursive (default) strategy is used
318 mkdir -p "$dotest"
319 echo "$onto" > "$dotest/onto"
320 prev_head=`git-rev-parse HEAD^0`
321 echo "$prev_head" > "$dotest/prev_head"
323 msgnum=0
324 for cmt in `git-rev-list --no-merges "$upstream"..ORIG_HEAD \
325                         | @@PERL@@ -e 'print reverse <>'`
326 do
327         msgnum=$(($msgnum + 1))
328         echo "$cmt" > "$dotest/cmt.$msgnum"
329 done
331 echo 1 >"$dotest/msgnum"
332 echo $msgnum >"$dotest/end"
334 end=$msgnum
335 msgnum=1
337 while test "$msgnum" -le "$end"
338 do
339         call_merge "$msgnum"
340         continue_merge
341 done
343 finish_rb_merge